Dictionary = function (parentID) {
	if(null == parentID) {
		this._parent = document.body;
	}
	else {
		if(document.getElementById(parentID)) {
			this._parent = document.getElementById(parentID);
		}
		else {
			this._parent = document.body;
		}
	}
	
	this._frag = null;
	this._js = "";
	this._css= "";
	this._langData="";
	this._data="";
	this._entryid=0;
};
function loadFunction(){
 	//var arr = document.getElementById("Collins_JS");
 	window.Debugger.print("LoadFunction");
 	//while(arr.length == 0){
 	//	arr = document.getElementById("Collins_JS");
 	//	window.Debugger.print(arr.length);
 	//}
	window.Initializer.initDict();
}

function loadIncludeFunction(){
	window.Includer.includeDictFiles();
}


function includeJSCSS(path) {
	window.Debugger.print(path);
	var cssTag = document.createElement('link');
	cssTag.setAttribute('rel','stylesheet');
	cssTag.setAttribute('type','text/css');
	cssTag.setAttribute('href',"'"+path+".css'");
	document.getElementsByTagName('head')[0].appendChild(cssTag);
	
}


Dictionary.prototype.create		= function() {
	
	var xmlDocString = window.XML_Loader.loadxml();
	var xmlDoc=(new DOMParser()).parseFromString(xmlDocString, "text/xml");  
	
	this._langData = loadXML("dict-lang.xml").getElementsByTagName("language")[0];
	if(null != this._langData) localize(this._langData);
	
	this._data = xmlDoc.getElementsByTagName("Dictionary");	
	//updateTpl();
	
	function localize(langData) {
		for(var i=0; i!= langData.childNodes.length; ++i) {
			if(langData.childNodes[i].nodeType == 3) {continue;}
			if(document.getElementById(langData.childNodes[i].tagName).value) {
				document.getElementById(langData.childNodes[i].tagName).value = langData.childNodes[i].textContent;
			}
			else {
				document.getElementById(langData.childNodes[i].tagName).innerHTML = langData.childNodes[i].textContent;
			}
		}
	}
		
	function loadXML(xml) {
		var fileName = xml;
		var xmlDoc = null;    
	    if (document.implementation && document.implementation.createDocument)
	    {
	        var xmlhttp = new XMLHttpRequest();
	        //xmlhttp.setRequestHeader("Content-Type","text/xml");
	        xmlhttp.open("GET",fileName,false);
	        xmlhttp.send();
	        xmlDoc = xmlhttp.responseXML;//xmlhttp.responseXML;
	        //xmlDoc = xmlhttp.responseXML;
	        //document.writeln("getxml");
	        //document.writeln(xmlhttp.readyState);
	    }
	    else 
	    {
	        xmlDoc = null;
	    }
	    
		if (xmlDoc == null)
		{
			//document.writeln("xmlDoc = null");
		}
		
		return xmlDoc;
	}
};

Dictionary.prototype.show			= function() {
	if("" != this._data) {
		for(var i=0; i!=this._data.length; ++i) {
			var tpl = this.processData(this._data[i]);
			
			this._parent.appendChild(tpl);
			
//			if(eval(this._data[i].getAttribute("id"))) {
//				eval(this._data[i].getAttribute("id"))();
//			}
			tpl.style.display = "block";
			
			if(!i) {
				tpl.getElementsByClassName("dic-contentFold")[0].style.display = "block";
				tpl.getElementsByClassName("arrow")[0].src="images/dict_title_bar_unfold.png";
				//insertFoldBar(this._parent);
			}
		}
		
		function insertFoldBar(parent) {
			//parent.appendChild(document.getElementById("fold-bar"));
			
			addFoldListener();
			parent.getElementsByClassName("fold-bar")[0].style.display = "block";
			
			function addFoldListener() {
				parent.getElementsByClassName("btnfold")[0].addEventListener("click", clickFoldUpAllListener, true);
				parent.getElementsByClassName("btnexpand")[0].addEventListener("click", clickFoldDownAllListener, true);
				
				function clickFoldUpAllListener(event) {
					var dic_contents = document.getElementsByClassName("dictionary");
					
					for(var i=0; i!=dic_contents.length; ++i) {
						dic_contents[i].getElementsByClassName("arrow")[0].src = "images/dict_title_bar_fold.png";
						dic_contents[i].getElementsByClassName("dic-contentFold")[0].style.display = "none";
					}
				};

				function clickFoldDownAllListener(event) {
					var dic_contents = document.getElementsByClassName("dictionary");
					
					for(var i=0; i!=dic_contents.length; ++i) {
						dic_contents[i].getElementsByClassName("arrow")[0].src = "images/dict_title_bar_unfold.png";
						dic_contents[i].getElementsByClassName("dic-contentFold")[0].style.display = "block";
					}
				};
			}
		}
	}
};

Dictionary.prototype.processData	= function(dic) {
	var tpl = document.getElementById("tpl").cloneNode(true);	
	tpl.id = dic.getAttribute("id");
	//tpl.getElementsByClassName("index_link")[0].href = "#" + dic.getAttribute("id");
	tpl.getElementsByClassName("dic-logo")[0].src = dic.getAttribute("logo");
	
	if(dic.getAttribute("title-bg")) {tpl.getElementsByClassName("dic-title")[0].style.backgroundImage = "url("+dic.getAttribute("title-bg")+")";}
	tpl.className = "dictionary";
	//tpl.style.display = "block";
	
	addListener();	
	
	tpl.getElementsByClassName("dic-title")[0].id = dic.getAttribute("id") + ":titleBkimage";
	tpl.getElementsByClassName("dicTitleText")[0].appendChild(document.createTextNode(dic.getAttribute("localizedName")));
	
	if (dic.getAttribute("flag") == "uninstall") {
		tpl.getElementsByClassName("download")[0].style.display = "block";
		tpl.getElementsByClassName("dic-content")[0].style.display = "none";
		tpl.getElementsByClassName("dic-fold")[0].style.display = "none";
		
		tpl.getElementsByClassName("download")[0].getElementsByClassName("btndownload")[0].setAttribute("pid", dic.getAttribute("id"));
		
		addDownloadListener();
	}
	else if(dic.getAttribute("flag") == "install") {
		var div_entry = document.createElement("div");
		div_entry.id = "INTSIG_ENTRY_Id_"+ (this._entryid)++;
		div_entry.className = "INTSIG_ENTRY";
		
		var dic_entry = dic.getElementsByTagName("INTSIG_ENTRY");
		for(var i=0; i!= dic_entry.length; ++i) {
			div_entry = this.createCustomTag(dic_entry[i], div_entry);
		}
		
		tpl.getElementsByClassName("dic-content")[0].appendChild(div_entry);
		
		tpl.getElementsByClassName("download")[0].style.display = "none";
		tpl.getElementsByClassName("dic-content")[0].style.display = "none";
	}
	
	return tpl;
	
	function addDownloadListener() {
		tpl.getElementsByClassName("btndownload")[0].addEventListener("click", clickDownloadAllListener, true);
		
		function responseToEndDownloadState(productID)
		{
			var divNode = document.getElementById(productID + ":titleBkimage");
			if (divNode != null)
				divNode.style.backgroundImage = "url(images/title_bar_collins.png)";
		}

		function clickDownloadAllListener() {
			//responseToStartDownloadState(this.getAttribute("pid"));
			//window.open("http://www.intsig.com?productID="+ this.getAttribute("pid"));
			
			window.Downloader.downloadDict(this.getAttribute("pid"));
			
			//function responseToStartDownloadState(productID)
			//{
			//	var divNode = document.getElementById(productID + ":titleBkimage");
			//	if (divNode != null)
			//		divNode.style.backgroundImage = "url(images/dict_detail_loading_bar.gif)";
			//}
		}
	}
	
	function addListener() {
		tpl.getElementsByClassName("dic-title")[0].addEventListener("click", clickTitleListener, true);
		tpl.getElementsByClassName("dic-fold")[0].addEventListener("click", clickFoldListener, true);
		
		function clickTitleListener(event) {
			var divContentFold = this.nextElementSibling.nextElementSibling;
			var arrow = this.getElementsByClassName("arrow")[0];
			
			if("none" == divContentFold.style.display) {
				divContentFold.style.display = "block";
				
				arrow.src="images/dict_title_bar_unfold.png";
			}
			else {
				divContentFold.style.display = "none";
				
				arrow.src="images/dict_title_bar_fold.png";
			}
		};

		function clickFoldListener(event) {
			var divContentFold = this.parentNode;
			divContentFold.previousElementSibling.previousElementSibling.getElementsByClassName("arrow")[0].src = "images/dict_title_bar_fold.png";
			divContentFold.style.display = "none";
		};
	}
};

Dictionary.prototype.createCustomTag= function(parent,appendTo){
	for(var i=0; i!=parent.childNodes.length; ++i) {
		var node = parent.childNodes[i];
		
		//Element
		if(1 == node.nodeType) {
			var div = document.createElement("intsig:customTag");
			div.className = node.tagName;
			//div.name = node.tagName;
			div.setAttribute("name",node.tagName);
			var atts = node.attributes;
			for (var j= 0; j <atts.length; j++)
			{
				div.setAttribute(atts[j].nodeName,atts[j].nodeValue);
			}
			div = this.createCustomTag(node, div);
			
			appendTo.appendChild(div);		
		}
		else if(3 == node.nodeType) {
			appendTo.appendChild(document.createTextNode(node.textContent));
		}
	}
	return appendTo;
};

