;
(function($) {
	$(".dicTitleText").bind("scroll", scroll).trigger("scroll");
	
	function scroll() {
		var $this = $(this);
		var strLen = strlen($(this).html());
		var fontSize = parseInt($(this).css("font-size"));		
		var lenPX = strLen * fontSize / 2;
		var width = $(this).width();
		
		var direction = -1;
		if(lenPX > width) {						
			scrollLeft();
		}
		
		function scrollLeft() {
			var left = parseInt($this.css("left"));
			
			$this.css({
				"left":			left+direction
			});
			
			if(0 <= left) {
				//Move left;
				direction = -1;
				
				setTimeout(scrollLeft, 1000);
			}
			else if(lenPX <= width-left) {
				direction = 1;
				
				setTimeout(scrollLeft, 1000);
			}			
			else {
				setTimeout(scrollLeft, 100);
			}			
		}
	}
	
	function strlen(str) {  
	    var len = 0;  
	    for (var i = 0; i < str.length; i++) {  
	        if (str.charCodeAt(i) > 255 || str.charCodeAt(i<0)) len += 2; else len ++;  
	    }  
	    return len;
	}  
})(jQuery);